import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { filter } from 'rxjs/operators';
import * as i2 from '@angular/common';
import { BrowserModule } from '@angular/platform-browser';

class NotifyService {
    constructor() {
        this.subject = new BehaviorSubject(null);
        this.toast$ = this.subject.asObservable()
            .pipe(filter(toast => toast !== null));
    }
    show(type, body, delay) {
        this.subject.next({ type, body, delay });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: () => [] });

class NotifyComponent {
    constructor() {
        this.remove = new EventEmitter();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.1.3", type: NotifyComponent, selector: "lib-notify", inputs: { alert: "alert", i: "i" }, outputs: { remove: "remove" }, ngImport: i0, template: "<div class=\"alert alert-{{alert.type}}\" \n  [style.bottom.px]=\"i*100\">\n  <span class=\"{{alert.type}}\"></span>\n  <p>{{alert.body}}</p>\n  <a class=\"close\" (click)=\"remove.emit(i)\">&times;</a>\n  </div>", styles: [".alert{position:fixed;right:10px;width:auto;min-width:300px;height:80px;padding:.75rem 1.25rem;margin-top:1rem;border:none;animation:move 1s both;box-sizing:border-box;outline:none;margin-bottom:10px;border-radius:10px;border:2px solid;text-shadow:2px 2px 4px #000000}.success:before{content:\"\\1f389  Success Alert\"}.update:before{content:\"\\1f504  Update Available\"}.warning:before{content:\"\\2757\\fe0f  Error Encountered\"}.delete:before{content:\"\\26a0\\fe0f  Stop and Read \"}.info:before{content:\"\\1f31f  Special Announcement\"}.alert-success{color:#fff;background-color:#04b20c}.alert-update{color:#fff;background-color:#ac0a89}.alert-warning{color:#fff;background-color:#ecb90d}.alert-delete{color:#fff;background-color:#e23f33}.alert-info{color:#fff;background-color:#2c8bd3}.close{position:absolute;top:7px;right:10px;font-size:1.5em;cursor:pointer}.alert-heading{margin-top:0}@keyframes move{0%{transform:translate(100%)}to{transform:translate(0)}}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-notify', template: "<div class=\"alert alert-{{alert.type}}\" \n  [style.bottom.px]=\"i*100\">\n  <span class=\"{{alert.type}}\"></span>\n  <p>{{alert.body}}</p>\n  <a class=\"close\" (click)=\"remove.emit(i)\">&times;</a>\n  </div>", styles: [".alert{position:fixed;right:10px;width:auto;min-width:300px;height:80px;padding:.75rem 1.25rem;margin-top:1rem;border:none;animation:move 1s both;box-sizing:border-box;outline:none;margin-bottom:10px;border-radius:10px;border:2px solid;text-shadow:2px 2px 4px #000000}.success:before{content:\"\\1f389  Success Alert\"}.update:before{content:\"\\1f504  Update Available\"}.warning:before{content:\"\\2757\\fe0f  Error Encountered\"}.delete:before{content:\"\\26a0\\fe0f  Stop and Read \"}.info:before{content:\"\\1f31f  Special Announcement\"}.alert-success{color:#fff;background-color:#04b20c}.alert-update{color:#fff;background-color:#ac0a89}.alert-warning{color:#fff;background-color:#ecb90d}.alert-delete{color:#fff;background-color:#e23f33}.alert-info{color:#fff;background-color:#2c8bd3}.close{position:absolute;top:7px;right:10px;font-size:1.5em;cursor:pointer}.alert-heading{margin-top:0}@keyframes move{0%{transform:translate(100%)}to{transform:translate(0)}}\n"] }]
        }], propDecorators: { alert: [{
                type: Input
            }], i: [{
                type: Input
            }], remove: [{
                type: Output
            }] } });

class NoftifyContainerComponent {
    constructor(service) {
        this.service = service;
        this.toasts = [];
    }
    ngOnInit() {
        this.service.toast$.subscribe((toast) => {
            this.toasts = [toast, ...this.toasts];
            setTimeout(() => this.toasts.pop(), toast.delay || 6000);
        });
    }
    remove(index) {
        this.toasts = this.toasts.filter((v, i) => i !== index);
        // this.toasts.splice(index, 1);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NoftifyContainerComponent, deps: [{ token: NotifyService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.1.3", type: NoftifyContainerComponent, selector: "app-notify-container", ngImport: i0, template: `
    <lib-notify *ngFor="let toast of toasts; let i=index" 
      [alert]="toast" [i]="i"
      (remove)="remove($event)"></lib-notify>
  `, isInline: true, dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: NotifyComponent, selector: "lib-notify", inputs: ["alert", "i"], outputs: ["remove"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NoftifyContainerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-notify-container', template: `
    <lib-notify *ngFor="let toast of toasts; let i=index" 
      [alert]="toast" [i]="i"
      (remove)="remove($event)"></lib-notify>
  ` }]
        }], ctorParameters: () => [{ type: NotifyService }] });

class NotifyModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.1.3", ngImport: i0, type: NotifyModule, declarations: [NotifyComponent,
            NoftifyContainerComponent], imports: [BrowserModule], exports: [NotifyComponent,
            NoftifyContainerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyModule, imports: [BrowserModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.3", ngImport: i0, type: NotifyModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NotifyComponent,
                        NoftifyContainerComponent
                    ],
                    imports: [
                        BrowserModule
                    ],
                    exports: [
                        NotifyComponent,
                        NoftifyContainerComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of notify
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NoftifyContainerComponent, NotifyComponent, NotifyModule, NotifyService };
//# sourceMappingURL=notify-toaster.mjs.map
